#include <iostream>
#include "calc3DPosition.h"

/**
 * @file б 3 ֤η׻μ
 * @brief б 3 ֤η׻
 * @param x1 x2 бǡ
 * @param N бǡο
 * @param F ù
 * @param f ξΥ
 * @param f1 f2 ׻Υ
 * @param t ֤¿ʥ٥ȥ
 * @param R ֤βž
 * @return б 3 
 * @author Kento YAMADA
 * @date 2009.09.30
 */
CvMat** calc3DPosition(const CvMat *x1,
                       const CvMat *x2,
                       const int N,
                       const CvMat *F,
                       const double f,
                       const double f1,
                       const double f2,
                       CvMat **t,
                       const CvMat *R) {

  /* {{{ ƹ P  Pp η׻ */
  CvMat *P = cvCreateMat(3, 4, CV_64FC1);
  CvMat *Pp = cvCreateMat(3, 4, CV_64FC1);
  CvMat *matTmp1 = cvCreateMat(3, 3, CV_64FC1);
  CvMat *matTmp2 = cvCreateMat(3, 4, CV_64FC1);
  CvMat *vecTmp1 = cvCreateMat(3, 1, CV_64FC1);

  cvSetIdentity(matTmp1);
  cvmSet(matTmp1, 2, 2, f / f1);
  cvSetZero(matTmp2);
  for(int i = 0; i < 3; i++) {
    cvmSet(matTmp2, i, i, 1.0);
  }
  cvmMul(matTmp1, matTmp2, P);

  cvmTranspose(R, matTmp1);
  for(int i = 0; i < 3; i++) {
    for(int j = 0; j < 3; j++) {
    cvmSet(matTmp2, i, j, -1*cvmGet(matTmp1, i, j));
    }
  }
  cvmMul(matTmp1, *t, vecTmp1);
  cvmSet(matTmp2, 0, 3, cvmGet(vecTmp1, 0, 0));
  cvmSet(matTmp2, 1, 3, cvmGet(vecTmp1, 1, 0));
  cvmSet(matTmp2, 2, 3, cvmGet(vecTmp1, 2, 0));
  cvSetIdentity(matTmp1);
  cvmSet(matTmp1, 2, 2, f / f2);
  cvmMul(matTmp1, matTmp2, Pp);
  /* }}} */

  /* {{{ 3 ֤η׻ */
  CvMat **X = new CvMat* [N];
  CvMat *A = cvCreateMat(4, 3, CV_64FC1);
  CvMat *b = cvCreateMat(4, 1, CV_64FC1);
  CvMat *matTmp3 = cvCreateMat(3, 4, CV_64FC1);
  for(int i = 0; i < N; i++) {
    X[i] = cvCreateMat(3, 1, CV_64FC1);
    cvmSet(A, 0, 0, cvmGet(x1, i, 0) * cvmGet(P, 2, 0) - f * cvmGet(P, 0, 0));
    cvmSet(A, 0, 1, cvmGet(x1, i, 0) * cvmGet(P, 2, 1) - f * cvmGet(P, 0, 1));
    cvmSet(A, 0, 2, cvmGet(x1, i, 0) * cvmGet(P, 2, 2) - f * cvmGet(P, 0, 2));
    
		cvmSet(A, 1, 0, cvmGet(x1, i, 1) * cvmGet(P, 2, 0) - f * cvmGet(P, 1, 0));
    cvmSet(A, 1, 1, cvmGet(x1, i, 1) * cvmGet(P, 2, 1) - f * cvmGet(P, 1, 1));
    cvmSet(A, 1, 2, cvmGet(x1, i, 1) * cvmGet(P, 2, 2) - f * cvmGet(P, 1, 2));
    
    cvmSet(A, 2, 0, cvmGet(x2, i, 0) * cvmGet(Pp, 2, 0) - f * cvmGet(Pp, 0, 0));
    cvmSet(A, 2, 1, cvmGet(x2, i, 0) * cvmGet(Pp, 2, 1) - f * cvmGet(Pp, 0, 1));
    cvmSet(A, 2, 2, cvmGet(x2, i, 0) * cvmGet(Pp, 2, 2) - f * cvmGet(Pp, 0, 2));
    
		cvmSet(A, 3, 0, cvmGet(x2, i, 1) * cvmGet(Pp, 2, 0) - f * cvmGet(Pp, 1, 0));
    cvmSet(A, 3, 1, cvmGet(x2, i, 1) * cvmGet(Pp, 2, 1) - f * cvmGet(Pp, 1, 1));
    cvmSet(A, 3, 2, cvmGet(x2, i, 1) * cvmGet(Pp, 2, 2) - f * cvmGet(Pp, 1, 2));

    cvmSet(b, 0, 0, -1 * (cvmGet(x1, i, 0) * cvmGet(P, 2, 3) - f * cvmGet(P, 0, 3)));
    cvmSet(b, 1, 0, -1 * (cvmGet(x1, i, 1) * cvmGet(P, 2, 3) - f * cvmGet(P, 1, 3)));
    cvmSet(b, 2, 0, -1 * (cvmGet(x2, i, 0) * cvmGet(Pp, 2, 3) - f * cvmGet(Pp, 0, 3)));
    cvmSet(b, 3, 0, -1 * (cvmGet(x2, i, 1) * cvmGet(Pp, 2, 3) - f * cvmGet(Pp, 1, 3)));

    cvmMulTransposed(A, matTmp1, 1);
    cvInvert(matTmp1, matTmp1, CV_SVD);
    cvmTranspose(A, matTmp3);
    cvmMul(matTmp1, matTmp3, matTmp3);
    cvmMul(matTmp3, b, X[i]);
	}
  /* }}} */

  /* {{{ ӽ */
  int condition = 0;
  for(int i = 0; i < N; i++) {
    if( cvmGet(X[i], 2, 0) > 0) {
      condition++;
    } else if( cvmGet(X[i], 2, 0) < 0) {
      condition--;
    }
  }
  if(condition < 0) {
    cvmSet(vecTmp1, 0, 0, -1.0);
    cvmSet(vecTmp1, 1, 0, -1.0);
    cvmSet(vecTmp1, 2, 0, -1.0);
    cvMul(vecTmp1, *t, *t);
    for(int i = 0; i < N; i++) {
      cvMul(vecTmp1, X[i], X[i]);
    }
  }
  /* }}} */

  /* {{{ Ѥ CvMat ʤɤγ */
  cvReleaseMat(&P);
  cvReleaseMat(&Pp);
  cvReleaseMat(&matTmp1);
  cvReleaseMat(&matTmp2);
  cvReleaseMat(&matTmp3);
  cvReleaseMat(&vecTmp1);
  cvReleaseMat(&A);
  cvReleaseMat(&b);
  /* }}} */

  return X;
}
