#include <iostream>
#include <math.h>
#include "fundamentalTaubin.h"

#define sq(x) ((x) * (x))

/**
 * @file Taubin ˡμ
 * @brief Taubin ˡѤƴùνͤ׻
 * @param x1 x2 бǡ
 * @param N бǡο
 * @param f ξΥ
 * @author Kento YAMADA
 * @date 2009.09.26
 */
CvMat* fundamentalTaubin(const CvMat *x1,
                         const CvMat *x2,
                         const int N,
                         const double f) {

  /* {{{ 8 ٥ȥ z η׻ */
	CvMat **z = new CvMat* [N];
  for(int i = 0; i < N; i++) {
    z[i] = cvCreateMat(8, 1, CV_64FC1);
    cvmSet(z[i], 0, 0, cvmGet(x1, i, 0) * cvmGet(x2, i, 0));
    cvmSet(z[i], 1, 0, cvmGet(x1, i, 0) * cvmGet(x2, i, 1));
    cvmSet(z[i], 2, 0, f * cvmGet(x1, i, 0));
    cvmSet(z[i], 3, 0, cvmGet(x1, i, 1) * cvmGet(x2, i, 0));
    cvmSet(z[i], 4, 0, cvmGet(x1, i, 1) * cvmGet(x2, i, 1));
    cvmSet(z[i], 5, 0, f * cvmGet(x1, i, 1));
    cvmSet(z[i], 6, 0, f * cvmGet(x2, i, 0));
    cvmSet(z[i], 7, 0, f * cvmGet(x2, i, 1));
  }
  /* }}} */

  /* {{{ 8x8  V0 η׻ */
  CvMat **V = new CvMat* [N];
  for(int i = 0; i < N; i++) {
    V[i] = cvCreateMat(8, 8, CV_64FC1);
    cvmSet(V[i], 0, 0, sq(cvmGet(x1, i, 0)) + sq(cvmGet(x2, i, 0)));
    cvmSet(V[i], 0, 1, cvmGet(x2, i, 0) * cvmGet(x2, i, 1));
    cvmSet(V[i], 0, 2, f * cvmGet(x2, i, 0));
    cvmSet(V[i], 0, 3, cvmGet(x1, i, 0) * cvmGet(x1, i, 1));
    cvmSet(V[i], 0, 4, 0.0);
    cvmSet(V[i], 0, 5, 0.0);
    cvmSet(V[i], 0, 6, f * cvmGet(x1, i, 0));
    cvmSet(V[i], 0, 7, 0.0);

    cvmSet(V[i], 1, 0, cvmGet(x2, i, 0) * cvmGet(x2, i, 1));
    cvmSet(V[i], 1, 1, sq(cvmGet(x1, i, 0)) + sq(cvmGet(x2, i, 1)));
    cvmSet(V[i], 1, 2, f * cvmGet(x2, i, 1));
    cvmSet(V[i], 1, 3, 0.0);
    cvmSet(V[i], 1, 4, cvmGet(x1, i, 0) * cvmGet(x1, i, 1));
    cvmSet(V[i], 1, 5, 0.0);
    cvmSet(V[i], 1, 6, 0.0);
    cvmSet(V[i], 1, 7, f * cvmGet(x1, i, 0));

		cvmSet(V[i], 2, 0, f * cvmGet(x2, i, 0));
    cvmSet(V[i], 2, 1, f * cvmGet(x2, i, 1));
    cvmSet(V[i], 2, 2, sq(f));
    cvmSet(V[i], 2, 3, 0.0);
    cvmSet(V[i], 2, 4, 0.0);
    cvmSet(V[i], 2, 5, 0.0);
    cvmSet(V[i], 2, 6, 0.0);
    cvmSet(V[i], 2, 7, 0.0);

    cvmSet(V[i], 3, 0, cvmGet(x1, i, 0) * cvmGet(x1, i, 1));
    cvmSet(V[i], 3, 1, 0.0);
    cvmSet(V[i], 3, 2, 0.0);
    cvmSet(V[i], 3, 3, sq(cvmGet(x1, i, 1)) + sq(cvmGet(x2, i, 0)));
    cvmSet(V[i], 3, 4, cvmGet(x2, i, 0) * cvmGet(x2, i, 1));
    cvmSet(V[i], 3, 5, f * cvmGet(x2, i, 0));
    cvmSet(V[i], 3, 6, f * cvmGet(x1, i, 1));
    cvmSet(V[i], 3, 7, 0.0);

    cvmSet(V[i], 4, 0, 0.0);
    cvmSet(V[i], 4, 1, cvmGet(x1, i, 0) * cvmGet(x1, i, 1));
    cvmSet(V[i], 4, 2, 0.0);
    cvmSet(V[i], 4, 3, cvmGet(x2, i, 0) * cvmGet(x2, i, 1));
    cvmSet(V[i], 4, 4, sq(cvmGet(x1, i, 1)) + sq(cvmGet(x2, i, 1)));
    cvmSet(V[i], 4, 5, f * cvmGet(x2, i, 1));
    cvmSet(V[i], 4, 6, 0.0);
    cvmSet(V[i], 4, 7, f * cvmGet(x1, i, 1));

    cvmSet(V[i], 5, 0, 0.0);
    cvmSet(V[i], 5, 1, 0.0);
    cvmSet(V[i], 5, 2, 0.0);
    cvmSet(V[i], 5, 3, f * cvmGet(x2, i, 0));
    cvmSet(V[i], 5, 4, f * cvmGet(x2, i, 1));
    cvmSet(V[i], 5, 5, sq(f));
    cvmSet(V[i], 5, 6, 0.0);
    cvmSet(V[i], 5, 7, 0.0);

    cvmSet(V[i], 6, 0, f * cvmGet(x1, i, 0));
    cvmSet(V[i], 6, 1, 0.0);
    cvmSet(V[i], 6, 2, 0.0);
    cvmSet(V[i], 6, 3, f * cvmGet(x1, i, 1));
    cvmSet(V[i], 6, 4, 0.0);
    cvmSet(V[i], 6, 5, 0.0);
    cvmSet(V[i], 6, 6, sq(f));
    cvmSet(V[i], 6, 7, 0.0);

    cvmSet(V[i], 7, 0, 0.0);
    cvmSet(V[i], 7, 1, f * cvmGet(x1, i, 0));
    cvmSet(V[i], 7, 2, 0.0);
    cvmSet(V[i], 7, 3, 0.0);
    cvmSet(V[i], 7, 4, f * cvmGet(x1, i, 1));
    cvmSet(V[i], 7, 5, 0.0);
    cvmSet(V[i], 7, 6, 0.0);
    cvmSet(V[i], 7, 7, sq(f));
  }
  /* }}} */

  /* {{{ 8 ٥ȥ zt η׻ */
  CvMat *zb = cvCreateMat(8, 1, CV_64FC1);
  cvSetZero(zb);
  for(int i = 0; i < N; i++) {
    cvmAdd(z[i], zb, zb);
  }
  for(int i = 0; i < 8; i++) {
    cvmSet(zb, i, 0, cvmGet(zb, i, 0) / (double)N);
  }
  CvMat **zt = new CvMat* [N];
  for(int i = 0; i < N; i++) {
    zt[i] = cvCreateMat(8, 1, CV_64FC1);
    cvmSub(z[i], zb, zt[i]);
  }
  /* }}} */

  /* {{{ 8x8  M  L η׻*/
  CvMat *M = cvCreateMat(8, 8, CV_64FC1);
  CvMat *L = cvCreateMat(8, 8, CV_64FC1);
  CvMat *MTmp = cvCreateMat(8, 8, CV_64FC1);
  cvSetZero(M);
  cvSetZero(L);
  cvSetZero(MTmp);

  for(int i = 0; i < N; i++) {
    cvmMulTransposed(zt[i], MTmp, 0);
    cvmAdd(M, MTmp, M);
    cvmAdd(L, V[i], L);
  }
  /* }}} */

  /* {{{ ̸ͭ٥ȥη׻ */
  CvMat *svdW = cvCreateMat(8, 8, CV_64FC1);
  CvMat *svdU = cvCreateMat(8, 8, CV_64FC1);
  CvMat *svdV = cvCreateMat(8, 8, CV_64FC1);
  cvSVD(L, svdW, svdU, svdV);

	CvMat *g = cvCreateMat(8, 1, CV_64FC1);
	CvMat *T = cvCreateMat(8, 8, CV_64FC1);
	CvMat *TTmp = cvCreateMat(8, 8, CV_64FC1);
	CvMat *IdMat = cvCreateMat(8, 8, CV_64FC1);
  cvSetZero(T);

	for(int i = 0; i < 8; i++) {
    for(int j = 0; j < 8; j++) {
      cvmSet(g, j, 0, cvmGet(svdU, j, i));
    }
    cvmMulTransposed(g, TTmp, 0);
    cvSetIdentity(IdMat, cvRealScalar(1.0 / std::sqrt(cvmGet(svdW, i, i))));
    cvmMul(IdMat, TTmp, TTmp);
    cvmAdd(T, TTmp, T);
  }

  cvmMul(T, M, M);
  cvmMul(M, T, M);
  cvSVD(M, svdW, svdU, svdV);

  CvMat *v = cvCreateMat(8, 1, CV_64FC1);
  for(int i = 0; i < 8; i++) {
    cvmSet(v, i, 0, cvmGet(svdU, i, 7));
  }
  cvmMul(T, v, v);
  cvNormalize(v, v);

  CvMat *u = cvCreateMat(9, 1, CV_64FC1);
  for(int i = 0; i < 8; i++) {
    cvmSet(u, i, 0, cvmGet(v, i, 0));
  }
  cvmSet(u, 8, 0, -cvDotProduct(v, zb) / sq(f));
  cvNormalize(u, u);

	CvMat *F = cvCreateMat(3, 3, CV_64FC1);
  for(int i = 0; i < 9; i++) {
    cvmSet(F, i/3, i%3, cvmGet(u, i, 0));
  }
  /* }}} */

  /* {{{ Ѥγ */
  delete [] z;
  delete [] V;
  delete [] zt;
  cvReleaseMat(&zb);
  cvReleaseMat(&M);
  cvReleaseMat(&L);
  cvReleaseMat(&MTmp);
  /* }}} */

  return F;
}
