#include <iostream>
#include <fstream>
#include <cv.h>
#include "3DRec.h"
#include "cmdline.h"      //!< ץ


/**
 * @file 3DRec.cc
 * @brief 2 ֤б 3 
 * @author Kento YAMADA
 * @date 2009.09.18
 */
int main(int argc, char **argv) {

	/* {{{ ץν */
  gengetopt_args_info args_info;  //!< ץѤι¤
	if(cmdline_parser(argc, argv, &args_info) != 0) {
    return -1;
	}
  /* }}} */

  /* {{{ Ƽѥ᡼ν */
  double f = args_info.default_focus_arg;  //!< ξΥ
  std::cout << "# ξΥ               : " << f << std::endl;
  std::cout << "# бμ«Ƚ : " << args_info.optimize_threshold_arg << std::endl;
  std::cout << "# EFNSμ«Ƚ         : " << args_info.efns_threshold_arg << std::endl;
  std::cout << "# Υη׻ˡ         : " ;
  if(args_info.focus_method_given) {
    if(args_info.focus_method_arg == std::string("Free")) {
      std::cout << "ͳΥˡ" << std::endl;
		} else if(args_info.focus_method_arg == std::string("Fixed")) {
      std::cout << "Υˡ" << std::endl;
		} else {
      std::cout << "ŤʿѾΥˡ" << std::endl;
    }
  } else {
    std::cout << "ŤʿѾΥˡ" << std::endl;
  }
  std::cout << std::endl;
  /* }}} */

	/* {{{ бǡɤ߹ߤȥǡμ */
	CvMat *image1, *image2;  //!< бκɸǼ
	int N = readFeature(args_info.input_file_arg, &image1, &image2);  //!< ħ
	if(N == 0) {
    std::cerr << "# ERROR : бǡɤ߹ߤ˼" << std::endl;
		return -1;
	}
  /* }}} */

	/* {{{ бǡȤꤢ */
#ifdef DEBUG
	for(int i = 0; i < N; i++) {
    std::cerr << cvmGet(image1, i, 0) << " "
              << cvmGet(image1, i, 1) << " : "
              << cvmGet(image2, i, 0) << " "
              << cvmGet(image2, i, 1) << std::endl;
  }
#endif  // 3DREC_DBG
	/* }}} */

	/* {{{ ùνͤ׻ */
  CvMat *F = cvCreateMat(3, 3, CV_64FC1);
  F = fundamentalTaubin(image1, image2, N, f);
  CvMat *initF = cvCreateMat(3, 3, CV_64FC1);
  cvCopy(F, initF);
  /* }}} */

  /* {{{ бȴùι */
  std::cout << "# бȴùι򳫻" << std::endl;
  optimizeFundamental(&image1, &image2, &F, N, f, args_info.optimize_threshold_arg, args_info.efns_threshold_arg, FUNDAMENTAL_UPDATE);
  CvMat *efnsF = cvCreateMat(3, 3, CV_64FC1);
  cvCopy(F, efnsF);
	std::cout << std::endl;
  /* }}} */

  /* {{{ Υη׻ */
  double f1, f2;
  std::cout << "# Υη׻򳫻" << std::endl;
  calcFocus(F, f, args_info.focus_method_arg, f1, f2);
  if(f1 == f && f2 == f) {
    std::cerr << "# ERROR : Υη׻˼" << std::endl;
    return -1;
  }
  std::cout << std::endl;
  /* }}} */

  /* {{{ αưѥ᡼η׻ */
  CvMat *t = cvCreateMat(3, 1, CV_64FC1);
  CvMat *R = cvCreateMat(3, 3, CV_64FC1);
  std::cout << "# αưѥ᡼η׻򳫻" << std::endl;
  calcMotionParameters(F, f1, f2, f, image1, image2, N, &t, &R);
  std::cout << std::endl;
  /* }}} */

  /* {{{ ùκƷ׻бǡι */
  CvMat *vecTmp1 = cvCreateMat(3, 1, CV_64FC1);
  CvMat *vecTmp2 = cvCreateMat(3, 1, CV_64FC1);
  CvMat *matTmp1 = cvCreateMat(3, 3, CV_64FC1);
  for(int i = 0; i < 3; i++) {
    for(int j = 0; j < 3; j++) {
      cvmSet(vecTmp1, j, 0, cvmGet(R, j, i));
    }
    cvCrossProduct(t, vecTmp1, vecTmp2);
    for(int j = 0; j < 3; j++) {
      cvmSet(matTmp1, j, i, cvmGet(vecTmp2, j, 0));
    }
  }
  CvMat *matTmp2 = cvCreateMat(3, 3, CV_64FC1);
  cvSetIdentity(matTmp2);
  cvmSet(matTmp2, 2, 2, f1 / f);
  cvmMul(matTmp2, matTmp1, matTmp1);
  cvSetIdentity(matTmp2);
  cvmSet(matTmp2, 2, 2, f2 / f);
  cvmMul(matTmp1, matTmp2, F);
  cvNormalize(F, F);

  std::cout << "# ¬̤Τб֤򳫻" << std::endl;
  optimizeFundamental(&image1, &image2, &F, N, f, args_info.optimize_threshold_arg, args_info.efns_threshold_arg, CORRESPOND_UPDATE);
  std::cout << std::endl;
  /* }}} */

  /* {{{ бǡ 3 ֤η׻ */
  CvMat **X;
  std::cout << "# бǡ 3 ֤η׻򳫻" << std::endl;
  X = calc3DPosition(image1, image2, N, F, f, f1, f2, &t, R);
  std::cout << std::endl;
  /* }}} */

  /* {{{ Ƽǡν */
  if(args_info.fundamental_file_given) {
		std::ofstream ofs;
    ofs.open(args_info.fundamental_file_arg);
		ofs << "# " << std::endl;
    for(int i = 0; i < 3; i ++) {
      ofs << "( ";
      for(int j = 0; j < 3; j++) {
        ofs << cvmGet(initF, i, j) << " ";
      }
      ofs << ")" << std::endl;
    }
    ofs << std::endl;
		ofs << "# EFNSǹ" << std::endl;
    for(int i = 0; i < 3; i ++) {
      ofs << "( ";
      for(int j = 0; j < 3; j++) {
        ofs << cvmGet(efnsF, i, j) << " ";
      }
      ofs << ")" << std::endl;
    }
    ofs << std::endl;
		ofs << "# ǽ" << std::endl;
    for(int i = 0; i < 3; i ++) {
      ofs << "( ";
      for(int j = 0; j < 3; j++) {
        ofs << cvmGet(F, i, j) << " ";
      }
      ofs << ")" << std::endl;
    }
    ofs.close();
  } else {
		std::cout << "# " << std::endl;
    for(int i = 0; i < 3; i ++) {
      std::cout << "( ";
      for(int j = 0; j < 3; j++) {
        std::cout << cvmGet(initF, i, j) << " ";
      }
      std::cout << ")" << std::endl;
    }
    std::cout << std::endl;
		std::cout << "# EFNSǹ" << std::endl;
    for(int i = 0; i < 3; i ++) {
      std::cout << "( ";
      for(int j = 0; j < 3; j++) {
        std::cout << cvmGet(efnsF, i, j) << " ";
      }
      std::cout << ")" << std::endl;
    }
    std::cout << std::endl;
		std::cout << "# ǽ" << std::endl;
    for(int i = 0; i < 3; i ++) {
      std::cout << "( ";
      for(int j = 0; j < 3; j++) {
        std::cout << cvmGet(F, i, j) << " ";
      }
      std::cout << ")" << std::endl;
    }
  }

  if(args_info.camera_file_given) {
		std::ofstream ofs;
    ofs.open(args_info.camera_file_arg);
    ofs << "# Υ []" << std::endl;
    ofs << "f1 : " << f1 << std::endl;
    ofs << "f2 : " << f2 << std::endl << std::endl;
    ofs << "# ¿ʥ٥ȥ" << std::endl;
    ofs << "( ";
    for(int i = 0; i < 3; i++) {
      ofs << cvmGet(t, i, 0) << " ";
    }
    ofs << ")t" << std::endl << std::endl;
    ofs << "# ž" << std::endl;
    for(int i = 0; i < 3; i++) {
      ofs << "( ";
      for(int j = 0; j < 3; j++) {
        ofs << cvmGet(R, i, j) << " ";
      }
      ofs << ")" << std::endl;
    }
    ofs.close();
  } else {
		std::cout << "# Υ []" << std::endl;
    std::cout << "f1 : " << f1 << std::endl;
    std::cout << "f2 : " << f2 << std::endl << std::endl;
    std::cout << "# ¿ʥ٥ȥ" << std::endl;
    std::cout << "( ";
    for(int i = 0; i < 3; i++) {
			std::cout << cvmGet(t, i, 0) << " ";
    }
		std::cout << ")t" << std::endl << std::endl;
    std::cout << "# ž" << std::endl;
    for(int i = 0; i < 3; i++) {
			std::cout << "( ";
      for(int j = 0; j < 3; j++) {
				std::cout << cvmGet(R, i, j) << " ";
      }
			std::cout << ")" << std::endl;
    }
  }

  if(args_info.three_d_file_given) {
		std::ofstream ofs;
    ofs.open(args_info.three_d_file_arg);
    ofs << "# 3 ǡ" << std::endl;
    ofs << "point" << std::endl;
    ofs << "# ǡ" << std::endl;
    ofs << N << std::endl;
    ofs << "# ǡ ()" << std::endl;
    for(int i = 0; i < N; i++) {
      ofs << cvmGet(X[i], 0, 0) << " " << cvmGet(X[i], 1, 0) << " " << cvmGet(X[i], 2, 0) << std::endl;
    }
    ofs << "# ǡ (ޤ)" << std::endl;
  } else {
		std::cout << "# 3 ǡ" << std::endl;
    std::cout << "point" << std::endl;
    std::cout << "# ǡ" << std::endl;
    std::cout << N << std::endl;
    std::cout << "# ǡ ()" << std::endl;
    for(int i = 0; i < N; i++) {
			std::cout << cvmGet(X[i], 0, 0) << " " << cvmGet(X[i], 1, 0) << " " << cvmGet(X[i], 2, 0) << std::endl;
    }
		std::cout << "# ǡ (ޤ)" << std::endl;
  }
  /* }}} */

	/* {{{ Ѥ CvMat  */
  cvReleaseMat(&image1);
  cvReleaseMat(&image2);
  cvReleaseMat(&vecTmp1);
  cvReleaseMat(&vecTmp2);
  cvReleaseMat(&matTmp1);
  cvReleaseMat(&F);
  cvReleaseMat(&initF);
  cvReleaseMat(&efnsF);
  delete [] X;
  /* }}} */

	return 0;
}
